diff --git a/contrib/amd/ldap-id.ms b/contrib/amd/ldap-id.ms
new file mode 100644
index 0000000..3c0d308
--- /dev/null
+++ b/contrib/amd/ldap-id.ms
@@ -0,0 +1,306 @@
+.pl 10.0i
+.po 0
+.ll 8.5i
+.lt 8.5i
+.nr LL 8.5i
+.nr LT 8.5i
+.ds LF Johansson
+.ds RF [Page %]
+.ds CF
+.ds LH Internet draft
+.ds RH 30 March 1998
+.ds CH Berkeley AMD LDAP Schema
+.hy 0
+.ad l
+.in 0
+INTERNET-DRAFT                                                         Leif Johansson
+Intented Category: Experimental                                  Stockholm University
+
+
+
+.ce
+A directory (X.500 and LDAPv3) schema for Berkely automounter
+
+
+.ti 0
+1. Status of this Memo
+
+.fi
+.in 3
+This memo describes a directory (LDAP or X.500) schema for storing
+amd (Berkely-style automounter) mount info maps. The schema is currently
+beeing supported by the (beta version of the) am-utils version 6 package
+[AMUTILS].
+
+.ti 0
+2. Overview and Rationale
+
+Directory services such as X.500 [X500] or LDAP [RFC2251] are a natural
+choice of repository for amd mount map databases. All Object Identifiers
+in this document are prefixed by amdSchema-id to be assigned later. The
+relation between this schema and the automount schema elements in [HOWARD]
+are mostly superficial. The model for the elements in [HOWARD] was the SUN
+automounter which has quite a different syntax for mount maps. Furthermore
+the intended usage of this schema differs from that of [HOWARD] in many
+respects.
+
+.ti 0
+3. DSA requirements
+
+Directory servers implementing this schema SHOULD maintain the
+modifyTimestamp operational attribute. If not the amdMapCacheTtl
+attribute SHOULD be set to 0 indicating to clients that caching of
+map entries SHOULD be turned off. Clients wishing to use the amdMap
+schema MAY use the modifyTimestamp information to set the ttl for
+internal caching schemes. A value of 0 for the amdMapCacheTtl must
+result in clients turning off any local caching.
+
+.ti 0
+4. Syntax definitions
+
+The following attribute syntax is defined in this document:
+
+     amdlocationlist
+
+This syntax represents a amd map value. This is the syntax expressed
+in BNF using definitions from [RFC2252]:
+
+     amdlocationlist      = amdlocationselection |
+                            amdlocationlist whsp "||" whsp amdlocationselection
+
+     amdlocationselection = amdlocation |
+                            amdlocationselection whsp amdlocation
+
+     amdlocation          = amdlocationinfo |
+                            "-" amdlocationinfo |
+                            "-"
+
+     amdlocationinfo      = seloropt |
+                            amdlocationinfo ";" seloropt |
+                            ";"
+
+     seloropt             = seletion |
+                            optass
+
+     selection            = keystring "==" printablestring
+                            keystring "!=" printablestring
+
+     optass               = keystring \":=\" printablestring
+
+X.500 servers or LDAPv3 servers (supporting the binary attribute
+option) may use the following syntax definition:
+
+     AmdLocationList ::= SEQUENCE OF {
+                            SEQUENCE OF {
+                               location     AmdLocation
+                            }
+                         }
+
+     AmdLocation     ::= SET OF {
+                            CHOICE {
+                               location     [0] AmdLocationInfo
+                               notlocation  [1] AmdLocationInfo
+                               not          [2] NULL
+                            }
+                         }
+
+     AmdLocationInfo ::= SET OF {
+                            CHOICE {
+                               selection    [0] AmdSelection
+                               option       [1] AmdOption
+                            }
+                         }
+
+     AmdSelection    ::= CHOICE {
+                            eq     [0] AttributeAndValue
+                            ne     [1] AttributeAndValue
+                         }
+
+     AmdOption       ::= AttributeAndValue
+
+     AttributeAndValue ::= SEQUENCE {
+                              attribute     IA5String
+                              value         IA5String
+                           }
+
+.ti 0
+5. Attribute types
+
+The following attribute types are defined in this document:
+
+     amdMapName
+     amdMapCacheTtl
+     amdMapEntry
+     amdMapEntryKey
+     amdMapEntryValue
+
+     amdSchema-a OBJECT IDENTIFIER ::= { amdSchema-id 1 }
+
+     amdMapName
+	ATTRIBUTE ::= {
+           WITH SYNTAX              IA5String
+           EQUALITY MATCHING RULE   caseIgoreExactMatch
+           --ID                     { amdSchema-a 1 }
+           DESCRIPTION
+            "This attribute is the symbolic and in the naming
+             context unique name of an amd map. This corresponds
+             in the case of a flat file database to the name of
+             the file or the mount-point of the map."
+        }
+
+
+     amdMapCacheTtl
+        ATTRIBUTE ::= {
+           WITH SYNTAX              Integer
+           EQUALITY MATCHING RULE   integerExactMatch
+           --ID                     { amdSchema-a 2 }
+           SINGLE VALUED
+           DESCRIPTION
+            "The maximum time-to-live for the entries in this
+             map. After this many milliseconds the map has to
+             be cleared from local caches and reloaded. A value
+             of 0 disables caching."
+        }
+
+     amdMapEntry
+        ATTRIBUTE ::= {
+           WITH SYNTAX              DistinguishedName
+           EQUALITY MATHCING RULE   dNCaseIgnoreExactMatch
+           --ID                     { amdSchema-a 3 }
+           DESCRIPTION
+            "A multivalued attribute listing the distinguished
+             names of the amdMapEntries making up this amdMap
+             object."
+        }
+
+     amdMapEntryKey ::= {
+        ATTRIBUTE ::= {
+           WITH SYNTAX              IA5String
+           EQUALITY MATCHING RULE   stringExactMatch
+           --ID                     { amdSchema-a 4 }
+           SINGLE VALUED
+           DESCRIPTION
+            "The value of this attribute is usually the name of
+             a mountpoint for this amdMapEntry."
+        }
+
+     amdMapEntryValue ::= {
+        ATTRIBUTE ::= {
+           WITH SYNTAX              AmdLocationList
+           --ID                     { amdSchema-a 5 }
+           DESCRIPTION
+            "This is the actual mount information for the amdMapEntry
+             using the syntax described above."
+        }
+
+     amdMapEntryKey ::= {
+        ATTRIBUTE ::= {
+           WITH SYNTAX              IA5String
+           EQUALITY MATCHING RULE   stringExactMatch
+           --ID                     { amdSchema-a 4 }
+           SINGLE VALUED
+           DESCRIPTION
+            "The value of this attribute is usually the name of
+             a mountpoint for this amdMapEntry."
+        }
+
+     amdMapEntryValue ::= {
+        ATTRIBUTE ::= {
+           WITH SYNTAX              AmdLocationList
+           --ID                     { amdSchema-a 5 }
+           DESCRIPTION
+            "This is the actual mount information for the amdMapEntry
+             using the syntax described above."
+        }
+
+.ti 0
+6. Object classes
+
+The following object classes are defined in this document:
+
+          amdMap
+          amdMapEntry
+
+defined as follows:
+
+          amdSchema-oc ::= { amdSchema-id 2 }
+
+          amdMap OBJECT-CLASS ::= {
+                    SUBCLASS OF            { top }
+                    KIND                   auxiliary
+                    --ID                   { amdSchema-oc 1 }
+                    MAY CONTAIN            { amdMapCacheTtl , cn }
+                    MUST CONTAIN           { amdMapName , amdMapEntry }
+                 }
+
+          amdMapEntry OBJECT-CLASS ::= {
+                         SUBCLASS OF       { top }
+                         KIND              structural
+                         --ID              { amdSchema-oc 2 }
+                         MUST CONTAIN      {
+                                             amdMapName ,
+                                             amdEntryKey ,
+                                             amdEntryValue ,
+                                           }
+	                 MAY CONTAIN       { cn }
+	                 DESCRIPTION
+		          "An entry of this object class describes mount
+	                   information relative to a certain amdMap entry"
+                      }
+
+.ti 0
+7. Examples
+
+
+
+.ti 0
+8. Security Considerations
+
+Due to the security problems posed by NFS care should be taken not to
+advertise exported filesystems. Therefore it is often desirable to limit
+access to entries carrying amd mount map information to those systems
+to which the corresponding filesystems have been exported.
+
+.ti 0
+9. References
+
+   [AMUTILS]
+        am-utils homepage: http://shekel.cs.columbia.edu/~erez/am-utils.html
+
+   [RFC2251]
+        M. Wahl, T. Howes, S. Kille, "Lightweight Directory Access
+        Protocol (v3)", RFC 2251, December 1997.
+
+   [RFC2252]
+        M. Wahl, A. Coulbeck, T. Howes, S. Kille, "Lightweight Directory
+        Access Protocol (v3): Attribute Syntax Definitions", RFC 2252,
+        December 1997.
+
+   [RFC2253]
+        M. Wahl, S. Kille, T. Howes, "Lightweight Directory Access
+        Protocol (v3): UTF-8 String Representation of Distinguished
+        Names", RFC 2253, December 1997.
+
+   [HOWARD]
+        Luke Howard, "An Approach for Using LDAP as a Network
+        Information Service", draft-howard-nis-schema-??.txt, Internet
+        draft.
+
+   [X500]
+        ITU something or other.
+
+.in 3
+
+
+.ti 0
+Author's Address
+
+.nf
+
+Leif Johansson
+Department of Mathematics
+Stockholm University
+S-106 91 Stockholm
+         SWEDEN
+
+Email: leifj@matematik.su.se
diff --git a/contrib/amd/ldap.schema b/contrib/amd/ldap.schema
new file mode 100644
index 0000000..9594d2f
--- /dev/null
+++ b/contrib/amd/ldap.schema
@@ -0,0 +1,52 @@
+# A schema for the Berkeley automounter (AMD)
+# Authored by Erez Zadok and/or source maintainers
+# Definition by Tim Colles <timc at dai.ed.ac.uk>
+# Revised by Adam Morley <adam at gmi.com>
+
+# OID Base is 1.3.6.1.4.1.10180
+#
+# Syntaxes are under 1.3.6.1.4.1.10180.3.175-199
+# Attribute types are under 1.3.6.1.4.1.10180.2.175-199
+# Object classes are under 1.3.6.1.4.1.10180.1.175-199
+
+# Attribute Type Definitions
+
+attributetype	( 1.3.6.1.4.1.10180.2.175
+	NAME	'amdmapTimestamp'
+	DESC	'Probably the time the map was last modified'
+	EQUALITY	integerMatch
+	SYNTAX	1.3.6.1.4.1.1466.115.121.1.27
+	SINGLE-VALUE )
+
+attributetype	( 1.3.6.1.4.1.10180.2.176
+	NAME	'amdmapName'
+	DESC	'The symbolic name of the map, ie. map_name'
+	EQUALITY	caseIgnoreMatch
+	SYNTAX	1.3.6.1.4.1.1466.115.121.1.15
+	SINGLE-VALUE )
+
+attributetype	( 1.3.6.1.4.1.10180.2.177
+	NAME	'amdmapKey'
+	DESC	'The key value for this entry'
+	EQUALITY	caseIgnoreMatch
+	SYNTAX	1.3.6.1.4.1.1466.115.121.1.15
+	SINGLE-VALUE )
+
+attributetype	( 1.3.6.1.4.1.10180.2.178
+	NAME	'amdmapValue'
+	DESC	'The mount information for this entry'
+	EQUALITY	caseIgnoreMatch
+	SYNTAX	1.3.6.1.4.1.1466.115.121.1.15
+	SINGLE-VALUE )
+
+# Object Class Definitions
+
+objectclass	( 1.3.6.1.4.1.10180.1.175 NAME 'amdmapTimestamp'
+	SUP	top STRUCTURAL
+	DESC	'Timestamp for an AMD map'
+	MUST	( cn $ amdmapName $ amdmapTimestamp ) )
+
+objectclass	( 1.3.6.1.4.1.10180.1.176 NAME 'amdmap'
+	SUP	top STRUCTURAL
+	DESC	'Defines an AMD map entry'
+	MUST	( cn $ amdmapName $ amdmapKey $ amdmapValue ) )
diff --git a/contrib/amd/libamu/amu.h b/contrib/amd/libamu/amu.h
index a22371e..1e7834a 100644
--- a/contrib/amd/libamu/amu.h
+++ b/contrib/amd/libamu/amu.h
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: amu.h,v 1.2 1999/01/10 21:54:36 ezk Exp $
+ * File: am-utils/libamu/amu.h
  *
  */
 
@@ -75,4 +74,6 @@ extern amq_mount_info_list *amqproc_getmntfs_1(voidp argp, CLIENT *rqstp);
 extern int *amqproc_mount_1(voidp argp, CLIENT *rqstp);
 extern amq_string *amqproc_getvers_1(voidp argp, CLIENT *rqstp);
 
+extern long get_server_pid(void);
+
 #endif /* not _AMU_H */
diff --git a/contrib/amd/libamu/hasmntopt.c b/contrib/amd/libamu/hasmntopt.c
index 5f19e71..14cceb5 100644
--- a/contrib/amd/libamu/hasmntopt.c
+++ b/contrib/amd/libamu/hasmntopt.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@ n * modification, are permitted provided that the following conditions
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: hasmntopt.c,v 1.2 1999/01/10 21:54:37 ezk Exp $
+ * File: am-utils/libamu/hasmntopt.c
  *
  */
 
@@ -49,7 +48,7 @@ n * modification, are permitted provided that the following conditions
 #include <amu.h>
 
 #ifndef MNTMAXSTR
-# define MNTMAXSTR	128
+# define MNTMAXSTR	256
 #endif /* not MNTMAXSTR */
 
 
@@ -59,7 +58,6 @@ n * modification, are permitted provided that the following conditions
  *
  * From: Piete Brooks <pb@cl.cam.ac.uk>
  */
-
 static char *
 nextmntopt(char **p)
 {
@@ -69,7 +67,7 @@ nextmntopt(char **p)
   /*
    * Skip past white space
    */
-  while (*cp && isspace(*cp))
+  while (*cp && isspace((int) *cp))
     cp++;
 
   /*
@@ -98,18 +96,19 @@ nextmntopt(char **p)
   return rp;
 }
 
+
 /*
  * replacement for hasmntopt if the system does not have it.
  */
 char *
-hasmntopt(mntent_t *mnt, char *opt)
+amu_hasmntopt(mntent_t *mnt, char *opt)
 {
   char t[MNTMAXSTR];
   char *f;
   char *o = t;
   int l = strlen(opt);
 
-  strcpy(t, mnt->mnt_opts);
+  xstrlcpy(t, mnt->mnt_opts, sizeof(t));
 
   while (*(f = nextmntopt(&o)))
     if (NSTREQ(opt, f, l))
diff --git a/contrib/amd/libamu/misc_rpc.c b/contrib/amd/libamu/misc_rpc.c
index fa402c3..de0a920 100644
--- a/contrib/amd/libamu/misc_rpc.c
+++ b/contrib/amd/libamu/misc_rpc.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: misc_rpc.c,v 1.2 1999/01/10 21:54:37 ezk Exp $
+ * File: am-utils/libamu/misc_rpc.c
  *
  */
 
@@ -93,7 +92,7 @@ pickup_rpc_reply(voidp pkt, int len, voidp where, XDRPROC_T_TYPE where_xdr)
   memset((voidp) &reply_msg, 0, sizeof(reply_msg));
   memset((voidp) &reply_xdr, 0, sizeof(reply_xdr));
 
-  reply_msg.acpted_rply.ar_results.where = (caddr_t) where;
+  reply_msg.acpted_rply.ar_results.where = where;
   reply_msg.acpted_rply.ar_results.proc = where_xdr;
 
   xdrmem_create(&reply_xdr, pkt, len, XDR_DECODE);
@@ -127,6 +126,13 @@ make_rpc_packet(char *buf, int buflen, u_long proc, struct rpc_msg *mp, voidp ar
 {
   XDR msg_xdr;
   int len;
+  /*
+   * Never cast pointers between different integer types, it breaks badly
+   * on big-endian platforms if those types have different sizes.
+   *
+   * Cast to a local variable instead, and use that variable's address.
+   */
+  enum_t local_proc = (enum_t) proc;
 
   xdrmem_create(&msg_xdr, buf, buflen, XDR_ENCODE);
 
@@ -139,7 +145,7 @@ make_rpc_packet(char *buf, int buflen, u_long proc, struct rpc_msg *mp, voidp ar
   /*
    * Called procedure number
    */
-  if (!xdr_enum(&msg_xdr, (enum_t *) & proc))
+  if (!xdr_enum(&msg_xdr, &local_proc))
     return -EIO;
 
   /*
@@ -166,3 +172,39 @@ make_rpc_packet(char *buf, int buflen, u_long proc, struct rpc_msg *mp, voidp ar
 
   return len;
 }
+
+
+/* get uid/gid from RPC credentials */
+int
+getcreds(struct svc_req *rp, uid_t *u, gid_t *g, SVCXPRT *nfsxprt)
+{
+  struct authunix_parms *aup = (struct authunix_parms *) NULL;
+#ifdef HAVE_RPC_AUTH_DES_H
+  struct authdes_cred *adp;
+#endif /* HAVE_RPC_AUTH_DES_H */
+
+  switch (rp->rq_cred.oa_flavor) {
+
+  case AUTH_UNIX:
+    aup = (struct authunix_parms *) rp->rq_clntcred;
+    *u = aup->aup_uid;
+    *g = aup->aup_gid;
+    break;
+
+#ifdef HAVE_RPC_AUTH_DES_H
+  case AUTH_DES:
+    adp = (struct authdes_cred *) rp->rq_clntcred;
+    *g = INVALIDID;		/* some unknown group id */
+    if (sscanf(adp->adc_fullname.name, "unix.%lu@", (u_long *) u) == 1)
+        break;
+    /* fall through */
+#endif /* HAVE_RPC_AUTH_DES_H */
+
+  default:
+    *u = *g = INVALIDID;	/* just in case */
+    svcerr_weakauth(nfsxprt);
+    return -1;
+  }
+
+  return 0;			/* everything is ok */
+}
